/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Qualidade de Fornecimento                                                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8570_QFOSTP_UPDATE_QFOMARPROD                                        */
/*                                                                            */
/* Descrio:                                                                 */
/*  Updata a Qualificao de Marca por Produto para um Teste de Produto pai   */
/*  e para os testes filhos.                                                  */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 21/11/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/******************************************************************************/
/* PARAMETROS:                                                                */
/* @P_NRTESTEPROD  -  Nmero de teste alterado.                               */
/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8570_QFOSTP_UPDATE_QFOMARPROD.SQL              */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8570_QFOSTP_UPDATE_QFOMARPROD.SQL              */
/******************************************************************************/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'UPDATE_QFOMARPROD' AND
	   TYPE = 'P' 		  AND
	   U.UID = O.UID          AND
	   U.NAME = USER)

   DROP PROCEDURE UPDATE_QFOMARPROD
GO

CREATE PROCEDURE UPDATE_QFOMARPROD
   (@P_NRTESTEPROD VARCHAR(10),
    @P_UTILIZAREND VARCHAR(1) = NULL) AS

DECLARE   @V_DTVALAPRTEST   DATETIME;
DECLARE   @V_DTTESTE        DATETIME;
DECLARE   @V_IDMARCAPRTES   VARCHAR(1);
DECLARE   @V_VRRENDATUTES   NUMERIC(7, 3);
DECLARE   @V_NRTESTEPROD    VARCHAR(10);
DECLARE   @V_COUNT          NUMERIC;
DECLARE   @V_CDPRODUTO      VARCHAR(10);
DECLARE   @V_CDMARCA        VARCHAR(5)
DECLARE   @V_CDPRODUTODOEST VARCHAR(10);

BEGIN
/* VALORES DO TESTE PAI QUE SERAO ATUALIZADOS NOS TESTES FILHOS */
   SELECT
      @V_DTVALAPRTEST = MAX(DTVALAPRTEST),
      @V_DTTESTE      = MAX(DTTESTE),
      @V_IDMARCAPRTES = MAX(IDMARCAPRTES),
      @V_VRRENDATUTES = MAX(VRRENDATUTES),
      @V_NRTESTEPROD  = MAX(NRTESTEPROD)
   FROM
      TESTEPROD
   WHERE
      NRTESTEPROD = @P_NRTESTEPROD;

/* UPDATA A QUALIFICACAO DO TESTE PAI E DOS FILHOS */
   DECLARE C_TESTEFILHO CURSOR FOR
   SELECT
      CDPRODUTO,
      CDMARCA,
      NRTESTEPROD
   FROM
      TESTEPROD
   WHERE
      NRTESTEPROD  = @P_NRTESTEPROD OR
      NRTESPRDORIG = @P_NRTESTEPROD;

   OPEN C_TESTEFILHO;

   FETCH NEXT FROM C_TESTEFILHO INTO @V_CDPRODUTO, @V_CDMARCA, @V_NRTESTEPROD;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_COUNT = 0;
      SELECT
        @V_COUNT = COUNT(*)
      FROM
        PRODUTO
      WHERE
        CDPRODESTO = @V_CDPRODUTO;

      IF @V_COUNT = 0 BEGIN
         SELECT
            @V_COUNT = COUNT(*)
         FROM
            QFOMARPROD
         WHERE
            CDPRODUTO   = @V_CDPRODUTO AND
            CDMARCA     = @V_CDMARCA;

         IF @V_COUNT <> 0
         BEGIN
            UPDATE QFOMARPROD
            SET DTVALAPROVA  = @V_DTVALAPRTEST,
                DTTESTEQUA   = @V_DTTESTE,
                IDAPRMARPRO  = @V_IDMARCAPRTES,

                VRRENDATU    = CASE @P_UTILIZAREND
                                 WHEN 'S' THEN @V_VRRENDATUTES
                                 WHEN 'X' THEN NULL
                                 ELSE VRRENDATU
                               END,


                IDAUTMARPRO  = 'N',
                NRTESTEPROD  = @V_NRTESTEPROD
            WHERE
               CDPRODUTO = @V_CDPRODUTO AND
               CDMARCA   = @V_CDMARCA;
         END
         ELSE
         BEGIN

            INSERT INTO QFOMARPROD (CDMARCA,     CDPRODUTO,  NRTESTEPROD,
                                    DTVALAPROVA, DTTESTEQUA, IDAPRMARPRO,
                                    VRRENDATU,   IDAUTMARPRO)
            VALUES (@V_CDMARCA,      @V_CDPRODUTO, @V_NRTESTEPROD,
                    @V_DTVALAPRTEST, @V_DTTESTE,   @V_IDMARCAPRTES,
                    CASE @P_UTILIZAREND
                       WHEN 'S' THEN @V_VRRENDATUTES
                       WHEN 'X' THEN NULL
                       ELSE 0
                     END, 'N');
         END;
      END
      ELSE BEGIN
         DECLARE C_PRODSESTO CURSOR FOR
         SELECT
           CDPRODUTO
         FROM
           PRODUTO
         WHERE
           CDPRODESTO = @V_CDPRODUTO

         OPEN C_PRODSESTO;

         FETCH NEXT FROM C_PRODSESTO INTO @V_CDPRODUTODOEST;

         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            SET @V_COUNT = 0;
            SELECT
               @V_COUNT = COUNT(*)
            FROM
               QFOMARPROD
            WHERE
               CDPRODUTO   = @V_CDPRODUTODOEST AND
               CDMARCA     = @V_CDMARCA;

            IF @V_COUNT <> 0
            BEGIN
               UPDATE QFOMARPROD
               SET DTVALAPROVA  = @V_DTVALAPRTEST,
                   DTTESTEQUA   = @V_DTTESTE,
                   IDAPRMARPRO  = @V_IDMARCAPRTES,
                   VRRENDATU    = CASE @P_UTILIZAREND
                                    WHEN 'S' THEN @V_VRRENDATUTES
                                    WHEN 'X' THEN NULL   
                                    ELSE VRRENDATU
                                  END,
                   IDAUTMARPRO  = 'N',
                   NRTESTEPROD  = @V_NRTESTEPROD
               WHERE
                  CDPRODUTO = @V_CDPRODUTODOEST AND
                  CDMARCA   = @V_CDMARCA;
            END
            ELSE
            BEGIN
               PRINT @V_CDMARCA;
               INSERT INTO QFOMARPROD (CDMARCA,     CDPRODUTO,  NRTESTEPROD,
                                       DTVALAPROVA, DTTESTEQUA, IDAPRMARPRO,
                                       VRRENDATU,   IDAUTMARPRO)
               VALUES (@V_CDMARCA,      @V_CDPRODUTODOEST, @V_NRTESTEPROD,
                       @V_DTVALAPRTEST, @V_DTTESTE,   @V_IDMARCAPRTES,
                       @V_VRRENDATUTES, 'N');
            END;

            FETCH NEXT FROM C_PRODSESTO INTO @V_CDPRODUTODOEST;
         END;
         CLOSE C_PRODSESTO;
         DEALLOCATE C_PRODSESTO;
      END;

      FETCH NEXT FROM C_TESTEFILHO INTO @V_CDPRODUTO, @V_CDMARCA, @V_NRTESTEPROD;

   END;
   CLOSE C_TESTEFILHO;
   DEALLOCATE C_TESTEFILHO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'UPDATE_QFOMARPROD','4.05.121';
GO

